########################################################################################################################
#
# Module: établissement du dictionnaire  de graphe avec les différents noeuds et leurs couts
#
# graphe est un dictionnaire qui comprend les sommets, les voisins et les couts
#
#
########################################################################################################################


from math import sqrt
from carte_parcours_robot import coord_point, vit_parcours


def cout(PX, PY):
    """ Cette fonction calcule le cout entre deux nœuds PX et PY,
    à partir des données entre les points adjacents de la carte """
    # variables disponibles
    # coord_point[PX][0] : abscisse de PX
    # coord_point[PX][1] : ordonnée de PX
    # vit_parcours[PX][PY] : vitesse entre PX et PY dans la carte
    # round(X,1) : arrondi de X à 1 chiffre après la virgule
    inf = float('inf')  # représente l'infini
    if vit_parcours[PX][PY] == 0:
        return inf

    #################################################################
    #    A COMPLETER
    #################################################################
  
    return calcul_cout


########################################################################
##        Définition du graphe avec les noeuds et les couts       ##
########################################################################

graphe = dict()  # dictionnaire
inf = float('inf')  # représente l'infini
# graphe['Pi'] = Les voisins du point Pi  et les couts pour aller vers ces voisins :
# on peut omettre les voisins  en inf (infini)  et en  0
# ex :graphe['A'] = {'A':0, 'B': 350, 'C': inf, 'D': 3, 'E': inf, 'F': inf, 'G': inf, 'H': inf, 'I': inf, ... 'T': inf}
# Z est le cas d'un point isolé
graphe['A'] = {'B': cout('A', 'B'), 'L': cout('A', 'L')}
graphe['B'] = {'A': cout('B', 'A'), 'C': cout('B', 'C'), 'K': cout('B', 'K')}
graphe['C'] = {'B': cout('C', 'B'), 'D': cout('C', 'D'), 'H': cout('C', 'H'), 'J': cout('C', 'J')}
graphe['D'] = {'C': cout('D', 'C'), 'E': cout('D', 'E'), 'H': cout('D', 'H')}
graphe['E'] = {'D': cout('E', 'D'), 'F': cout('E', 'F')}
graphe['F'] = {'E': cout('F', 'E'), 'G': cout('F', 'G'), 'S': cout('F', 'S')}
graphe['G'] = {'H': cout('G', 'H'), 'I': cout('G', 'I'), 'F': cout('G', 'F'), 'R': cout('G', 'R')}
graphe['H'] = {'C': cout('H', 'C'), 'D': cout('H', 'D'), 'G': cout('H', 'G')}
graphe['I'] = {'G': cout('I', 'G'), 'J': cout('I', 'J'), 'Q': cout('I', 'Q')}
graphe['J'] = {'C': cout('J', 'C'), 'I': cout('J', 'C'), 'K': cout('J', 'K')}
graphe['K'] = {'B': cout('K', 'B'), 'J': cout('K', 'J'), 'O': cout('K', 'O'), 'P': cout('K', 'P')}
graphe['L'] = {'A': cout('L', 'A'), 'M': cout('L', 'M'), 'O': cout('L', 'O')}
graphe['M'] = {'L': cout('M', 'L'), 'N': cout('M', 'N')}
graphe['N'] = {'M': cout('N', 'M'), 'O': cout('N', 'O'), 'T': cout('N', 'T')}
graphe['O'] = {'K': cout('O', 'K'), 'L': cout('O', 'L'), 'N': cout('O', 'N')}
graphe['P'] = {'K': cout('P', 'K'), 'Q': cout('P', 'Q'), 'T': cout('P', 'T')}
graphe['Q'] = {'I': cout('Q', 'I'), 'P': cout('Q', 'P'), 'R': cout('Q', 'R')}
graphe['R'] = {'G': cout('R', 'G'),'Q': cout('R', 'Q'), 'S': cout('R', 'S')}
graphe['S'] = {'F': cout('S', 'F'), 'R': cout('S', 'R')}
graphe['T'] = {'N': cout('T', 'N'), 'P': cout('T', 'P')}
graphe['Z'] = {}  # cas d'un point isolé
